import {
	ArrayField, ArrayUtil,
	btn,
	Sortable, ContainerField,
	containerfield,
	t, textfield
} from "@intermesh/goui";

export class ProjectMilestones extends ArrayField {

	constructor() {
		super(() => {
			const field = containerfield({
					cls: "group",
				},

				textfield({
					flex: 1,
					label: t("Name"),
					name: "name",
				}),

				btn({
					icon: "delete",
					title: "Delete",
					handler: (btn) => {
						field.remove();
					}
				}),

				btn({
					cls: "handle",
					icon: "drag_handle",
					title: "Sort",
					listeners: {
						render: comp => {
							comp.el.addEventListener("mousedown", () => {
								const row = comp.findAncestorByType(ContainerField)!
								row.el.draggable = true;
							})

							comp.el.addEventListener("mouseup", () => {
								const row = comp.findAncestorByType(ContainerField)!
								row.el.draggable = false;
							})
						}
					}
				})

			);

			return field;
		});

		this.name = "milestones";

		this.on("render", comp => {

			const sortable = new Sortable(comp, ".group");

			sortable.on("sort", (field, fromIndex, toIndex) => {
				field.value = ArrayUtil.move(field.value, fromIndex, toIndex);
			})

		});

	}
}